﻿using IRaCIS.Core.Application.Contracts;
using IRaCIS.Core.Application.Service.Inspection.DTO;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IRaCIS.Core.Application.Service.Inspection.Interface
{
    public interface IInspectionService
    {

        Task<PageOutput<GetDataInspectionOutDto>> GetInspectionData(GetDataInspectionDto dto);

        void MapData(dynamic data, dynamic mapData);

        Task<IResponseOutput> VerifySignatureAsync(SignDTO signDTO);

        Task<Guid> AddSignRecordAsync(SignDTO signDTO);

        Task<dynamic> Enforcement(dynamic OptCommand, DataInspectionAddDTO AuditInfo, SignDTO SignInfo, dynamic fun, IResponseOutput? response = null, object? Statusdata = null);

        Task<IResponseOutput> AddInspectionRecordAsync(DataInspectionAddDTO addDto, Guid? signId, object? Statusdata = null);
    }
}
