﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    public class TrialSite : Entity, IAuditAdd, IAuditUpdate,ISoftDelete
    {

        public Guid TrialId { get; set; }

        public Guid SiteId { get; set; }

        public string TrialSiteCode { get; set; } = String.Empty;

        public string TrialSiteAliasName { get; set; }=String.Empty;

        public Guid CreateUserId { get; set; }
        public DateTime CreateTime { get; set; }
        public Guid UpdateUserId { get; set; }
        public DateTime UpdateTime { get; set; }

        public bool IsDeleted { get; set; }


        //导航属性  
        [ForeignKey("SiteId")]
        public Site Site { get; set; }

        [ForeignKey("TrialId")]
        public Trial Trial { get; set; }



        /// <summary>
        /// Site 下面有多个访视记录
        /// </summary>
        public List<SubjectVisit> SubjectVisitList { get; set; }

        public List<TrialSiteSurvey> TrialSiteSurveyList { get; set; }


        //Site 由多个人负责
        public List<TrialSiteUser> CRCUserList { get; set; }


        public List<Subject> SubjectList { get; set; }

        public List<DicomStudy> StudyList { get; set; }

        public List<NoneDicomStudy> NoneDicomStudyList { get; set; }


        public  List<StudyMonitor> StudyMonitorList { get; set; }
    }
}